#pragma once

#include <core/global_definitions.hpp>
#include <boost/shared_ptr.hpp>

namespace CoGaDB{
    
    class Bitmap{
    public:    
        Bitmap(char* bitmap, size_t num_of_bits);
        Bitmap(size_t num_of_bits, bool init_value=false, bool initialize=true);
        ~Bitmap();
        char* data();
        size_t size() const;
    private:
        Bitmap(const Bitmap&);
        Bitmap& operator=(const Bitmap&);
        char* bitmap_;
        size_t num_of_bits_;
    };
    typedef boost::shared_ptr<Bitmap> BitmapPtr;
        
bool operator==(Bitmap& bitmap1, Bitmap& bitmap2);
bool operator!=(Bitmap& bitmap1, Bitmap& bitmap2);
        
}; //end namespace CoGaDB


