#pragma once

#include <string>
#include <core/global_definitions.hpp>
#include <hype.hpp>

namespace CoGaDB{


	class RuntimeConfiguration{
		public:
		static RuntimeConfiguration& instance();
		void setPathToDatabase(const std::string&);
		const std::string& getPathToDatabase();
		void setOptimizer(const std::string&);
		const std::string& getOptimizer();
                void setParallelizationModeForTwoPhasePhysicalOptimizationQueryPlans(ParallelizationMode);
                ParallelizationMode getParallelizationModeForTwoPhasePhysicalOptimizationQueryPlans() const;
                bool getPrintQueryPlan() const;                
                void setPrintQueryPlan(bool);
                bool getProfileQueries() const;                
                void setProfileQueries(bool);  
        void setQueryChoppingEnabled(bool);
        bool isQueryChoppingEnabled() const;
                bool setGlobalDeviceConstraint(const hype::DeviceConstraint&);
                hype::DeviceConstraint getGlobalDeviceConstraint() const;
		private:
		RuntimeConfiguration();
                RuntimeConfiguration(const RuntimeConfiguration&);
                RuntimeConfiguration& operator=(RuntimeConfiguration&);
		std::string path_to_database_;
                std::string optimizer_name_;
                bool print_query_plan_;
                bool enable_profiling_;
                bool enable_query_chopping_;
                hype::DeviceConstraint global_device_constraint_;
                ParallelizationMode two_phase_physical_optimization_parallelization_mode;
	};

}; //end namespace CogaDB

