#pragma once
#ifndef __CUDACC__
	#error "cannot compile header file __FILE__: you have to use nvcc!"
#endif

#include <gpu/gpu_base_column.hpp>

#include <thrust/device_vector.h>

namespace CoGaDB{
	namespace gpu{		

		class Impl_GPU_Positionlist : public GPU_Positionlist{
			public:
			Impl_GPU_Positionlist();
			virtual ~Impl_GPU_Positionlist();
			explicit Impl_GPU_Positionlist(const PositionList* pos_list);
			explicit Impl_GPU_Positionlist(const thrust::device_vector<TID>& pos_list);
			virtual void clear();
			virtual const GPU_PositionlistPtr aggregate(GPU_PositionlistPtr dev_tids) const;
			virtual bool insert(std::vector<TID>* pos_list);
			virtual size_t size() const throw();
			virtual const std::type_info& type() const throw();
			virtual const boost::any get(TID tid);
			virtual const PositionListPtr toHostPositionlist() const;
			virtual void print() const throw();
			thrust::device_vector<TID>& getContent();
			private:
			thrust::device_vector<TID> pos_list_;
		};

		

	}; //end namespace gpu
}; //end namespace CogaDB
		

