#pragma once

#include <core/bitmap.hpp>
#include <core/positionlist.hpp>
#include <gpu/gpu_base_column.hpp>

namespace CoGaDB {
    namespace query_processing {
        
        class BitmapOperator{
        public:
            bool hasResultBitmap();
            bool hasCachedResult_GPU_Bitmap();
            BitmapPtr getResultBitmap();
            gpu::GPU_BitmapPtr getResult_GPU_Bitmap();
        protected:
            BitmapPtr cpu_bitmap_;
            gpu::GPU_BitmapPtr gpu_bitmap_;
        };
        
//            bool BitmapOperator::hasResultBitmap(){
//                return (cpu_bitmap_!=NULL);
//            }
//            bool BitmapOperator::hasCachedResult_GPU_Bitmap(){
//                return (gpu_bitmap_!=NULL);
//            }
//            BitmapPtr BitmapOperator::getResultBitmap(){
//                return cpu_bitmap_;
//            }
//            gpu::GPU_BitmapPtr BitmapOperator::getResult_GPU_Bitmap(){
//                return gpu_bitmap_;
//            }
        
        class PositionListOperator{
        public:
            bool hasResultPositionList();
            bool hasCachedResult_GPU_PositionList();
            PositionListPtr getResultPositionList();
            gpu::GPU_PositionlistPtr getResult_GPU_PositionList();
        protected:
            PositionListPtr cpu_tids_;
            gpu::GPU_PositionlistPtr gpu_tids_;
        };
        
//            bool PositionListOperator::hasResultPositionList(){
//                return (cpu_tids_!=NULL);
//            }
//            bool PositionListOperator::hasCachedResult_GPU_PositionList(){
//                return (gpu_tids_!=NULL);
//            }
//            PositionListPtr PositionListOperator::getResultPositionList(){
//                return cpu_tids_;
//            }
//            gpu::GPU_PositionlistPtr PositionListOperator::getResult_GPU_PositionList(){
//                return gpu_tids_;
//            }
        
    
    }; //end namespace CoGaDB
}; //end namespace CoGaDB


