

#include <core/global_definitions.hpp>
#include <core/bitmap.hpp>

namespace CoGaDB{
        
    Bitmap::Bitmap(char* bitmap, size_t num_of_bits) : bitmap_(bitmap), num_of_bits_(num_of_bits){
        assert(bitmap_!=NULL);
    }
    Bitmap::Bitmap(size_t num_of_bits, bool init_value, bool initialize) : bitmap_(NULL), num_of_bits_(num_of_bits){
        if(initialize){
            if(init_value){
                bitmap_ = (char*) malloc((num_of_bits+7)/8);
                memset(bitmap_, 255, ((num_of_bits+7)/8)); 
            }else{
                bitmap_ = (char*) calloc((num_of_bits+7)/8,sizeof(char));
            }
        }else{
                bitmap_ = (char*) malloc((num_of_bits+7)/8);
        }
        assert(bitmap_!=NULL);
    }
    Bitmap::~Bitmap(){
        if(bitmap_){
            free(bitmap_);
            bitmap_=NULL;
        }
    }
    char* Bitmap::data(){
        return bitmap_;
    }
    size_t Bitmap::size() const{
        return num_of_bits_;
    }
    
bool operator==(Bitmap& bitmap1, Bitmap& bitmap2){
    if(bitmap1.size()!=bitmap2.size()){
        return false;
    }
    char* bitmap1_data = bitmap1.data();
    char* bitmap2_data = bitmap2.data();
    
    unsigned int number_of_bits=bitmap1.size();
        for(unsigned int i=0;i<number_of_bits;++i){
            unsigned int current_bit = i & 7; //i%8;
            unsigned int bitmask = 1 << current_bit;
            char bitmap1_value = bitmap1_data[i/8];
            char bitmap2_value = bitmap2_data[i/8];
            if((bitmap1_value & bitmask)!=(bitmap2_value & bitmask)){
                return false;
            }
        }
    return true;
}
bool operator!=(Bitmap& bitmap1, Bitmap& bitmap2){
    return !operator==(bitmap1,bitmap2);
}
    

}; //end namespace CoGaDB
