
#include <core/selection_expression.hpp>
#include <iostream>
#include <util/iostream.hpp>
#include <util/getname.hpp>
#include <sstream> 

namespace CoGaDB{
    using namespace std;

        Predicate::Predicate(const std::string& column1_name, const std::string& column2_name,PredicateType pred_t, ValueComparator comp) 
	: pred_t_(pred_t), column1_name_(column1_name), column2_name_(column2_name), constant_(),comp_(comp){ assert(pred_t==ValueValuePredicate);}

	Predicate::Predicate(const std::string& column1_name, const boost::any& constant,PredicateType pred_t, ValueComparator comp) 
	: pred_t_(pred_t), column1_name_(column1_name), column2_name_(),constant_(constant),comp_(comp){assert(pred_t==ValueConstantPredicate);}

        PredicateType Predicate::getPredicateType() const{
            return this->pred_t_;
        }
        const std::string& Predicate::getColumn1Name() const{
            return this->column1_name_;
        }
        const std::string& Predicate::getColumn2Name() const{
            return this->column2_name_;
        }
        const boost::any& Predicate::getConstant() const{
            return this->constant_;
        }
        ValueComparator Predicate::getValueComparator() const{
            return this->comp_;
        }
        void Predicate::print() const{
            std::cout << this->toString() << std::endl;
        }
        std::string Predicate::toString() const{
            std::string result;
            
            if(pred_t_==ValueValuePredicate){
                result+=column1_name_;
                result+=util::getName(comp_);            
                result+=column2_name_;
            }else if(pred_t_==ValueConstantPredicate){
                //result+=
                result+=column1_name_;
                result+=util::getName(comp_);
                std::stringstream ss;
                ss << constant_;
                result+=ss.str();
                //result+=")";              
            }else{
                cout << "FATAL ERROR! In Predicate::toString(): Invalid PredicateType" << endl;
                cout << "In File " << __FILE__ << ":" << __LINE__ << endl;
                exit(-1);
            }
            
         
            return result;
        }        
}