
#include <query_processing/operator_extensions.hpp>

namespace CoGaDB {
    namespace query_processing {
        
        bool BitmapOperator::hasResultBitmap(){
            return (cpu_bitmap_!=NULL);
        }
        bool BitmapOperator::hasCachedResult_GPU_Bitmap(){
            return (gpu_bitmap_!=NULL);
        }
        BitmapPtr BitmapOperator::getResultBitmap(){
            return cpu_bitmap_;
        }
        gpu::GPU_BitmapPtr BitmapOperator::getResult_GPU_Bitmap(){
            return gpu_bitmap_;
        }

        bool PositionListOperator::hasResultPositionList(){
            return (cpu_tids_!=NULL);
        }
        bool PositionListOperator::hasCachedResult_GPU_PositionList(){
            return (gpu_tids_!=NULL);
        }
        PositionListPtr PositionListOperator::getResultPositionList(){
            return cpu_tids_;
        }
        gpu::GPU_PositionlistPtr PositionListOperator::getResult_GPU_PositionList(){
            return gpu_tids_;
        }
        
    
    }; //end namespace query_processing
}; //end namespace CoGaDB