#include <util/tpch_benchmark.hpp>
#include <persistence/storage_manager.hpp>

using namespace std;

namespace CoGaDB{


bool Unittest_Create_TPCH_Database(const std::string& path_to_files){

	//TPCH Table
//CREATE TABLE NATION  ( N_NATIONKEY  INTEGER NOT NULL,
//                            N_NAME       CHAR(25) NOT NULL,
//                            N_REGIONKEY  INTEGER NOT NULL,
//                            N_COMMENT    VARCHAR(152));

	{
	cout << "Create Table 'NATION' ..." << endl;
	TableSchema schema;
	schema.push_back(Attribut(INT,"N_NATIONKEY"));
	schema.push_back(Attribut(VARCHAR,"N_NAME"));
	schema.push_back(Attribut(INT,"N_REGIONKEY"));
	schema.push_back(Attribut(VARCHAR,"N_COMMENT"));
	
	TablePtr tab1(new Table("NATION",schema));

	if(tab1->loadDatafromFile(path_to_files+"nation.tbl")){
	//tab1->print();
	cout << "Store Table 'NATION' ..." << endl;
	storeTable(tab1);
	}

	}

//CREATE TABLE REGION  ( R_REGIONKEY  INTEGER NOT NULL,
//                            R_NAME       CHAR(25) NOT NULL,
//                            R_COMMENT    VARCHAR(152));

	{
	cout << "Create Table 'REGION' ..." << endl;
	TableSchema schema2;
	schema2.push_back(Attribut(INT,"R_REGIONKEY"));
	schema2.push_back(Attribut(VARCHAR,"R_NAME"));
	schema2.push_back(Attribut(VARCHAR,"R_COMMENT"));
	TablePtr tab2(new Table("REGION",schema2));

	if(tab2->loadDatafromFile(path_to_files+"region.tbl")){
	//tab2->print();
	cout << "Store Table 'REGION' ..." << endl;
	storeTable(tab2);
	}
	}


/*
CREATE TABLE part  ( P_PARTKEY     INTEGER NOT NULL,
                          P_NAME        VARCHAR(55) NOT NULL,
                          P_MFGR        CHAR(25) NOT NULL,
                          P_BRAND       CHAR(10) NOT NULL,
                          P_TYPE        VARCHAR(25) NOT NULL,
                          P_SIZE        INTEGER NOT NULL,
                          P_CONTAINER   CHAR(10) NOT NULL,
                          P_RETAILPRICE DECIMAL(15,2) NOT NULL,
                          P_COMMENT     VARCHAR(23) NOT NULL )
engine=brighthouse;
//*/


	{
	cout << "Create Table 'PART' ..." << endl;
	TableSchema schema;
        schema.push_back(Attribut(INT,"P_PARTKEY"));
        schema.push_back(Attribut(VARCHAR,"P_NAME"));
        schema.push_back(Attribut(VARCHAR,"P_MFGR"));
        schema.push_back(Attribut(VARCHAR,"P_BRAND"));
        schema.push_back(Attribut(VARCHAR,"P_TYPE"));
        schema.push_back(Attribut(INT,"P_SIZE"));
        schema.push_back(Attribut(VARCHAR,"P_CONTAINER"));
        schema.push_back(Attribut(FLOAT,"P_RETAILPRICE"));
        schema.push_back(Attribut(VARCHAR,"P_COMMENT"));

	TablePtr tab(new Table("PART",schema));

	if(tab->loadDatafromFile(path_to_files+"part.tbl")){
	cout << "Store Table 'PART' ..." << endl;
	storeTable(tab);
	}
	}

/*
CREATE TABLE supplier ( S_SUPPKEY     INTEGER NOT NULL,
                             S_NAME        CHAR(25) NOT NULL,
                             S_ADDRESS     VARCHAR(40) NOT NULL,
                             S_NATIONKEY   INTEGER NOT NULL,
                             S_PHONE       CHAR(15) NOT NULL,
                             S_ACCTBAL     DECIMAL(15,2) NOT NULL,
                             S_COMMENT     VARCHAR(101) NOT NULL)
engine=brighthouse;
//*/
	{
	cout << "Create Table 'SUPPLIER' ..." << endl;
	TableSchema schema;
        schema.push_back(Attribut(INT,"S_SUPPKEY"));
        schema.push_back(Attribut(VARCHAR,"S_NAME"));
        schema.push_back(Attribut(VARCHAR,"S_ADDRESS"));
        schema.push_back(Attribut(INT,"S_NATIONKEY"));
        schema.push_back(Attribut(VARCHAR,"S_PHONE"));
        schema.push_back(Attribut(FLOAT,"S_ACCTBAL"));
        schema.push_back(Attribut(VARCHAR,"S_COMMENT"));
	TablePtr tab(new Table("SUPPLIER",schema));

	if(tab->loadDatafromFile(path_to_files+"supplier.tbl")){
	cout << "Store Table 'SUPPLIER' ..." << endl;
	storeTable(tab);
	}
	}

/*
CREATE TABLE partsupp ( PS_PARTKEY     INTEGER NOT NULL,
                             PS_SUPPKEY     INTEGER NOT NULL,
                             PS_AVAILQTY    INTEGER NOT NULL,
                             PS_SUPPLYCOST  DECIMAL(15,2)  NOT NULL,
                             PS_COMMENT     VARCHAR(199) NOT NULL )
engine=brighthouse;
//*/

	{
	cout << "Create Table 'PARTSUPP' ..." << endl;
	TableSchema schema;
        schema.push_back(Attribut(INT,"PS_PARTKEY"));
        schema.push_back(Attribut(INT,"PS_SUPPKEY"));
        schema.push_back(Attribut(INT,"PS_AVAILQTY"));
        schema.push_back(Attribut(FLOAT,"PS_SUPPLYCOST"));
        schema.push_back(Attribut(VARCHAR,"PS_COMMENT"));
	TablePtr tab(new Table("PARTSUPP",schema));

	if(tab->loadDatafromFile(path_to_files+"partsupp.tbl")){
	cout << "Store Table 'PARTSUPP' ..." << endl;
	storeTable(tab);
	}
	}
/*
CREATE TABLE customer ( C_CUSTKEY     INTEGER NOT NULL,
                             C_NAME        VARCHAR(25) NOT NULL,
                             C_ADDRESS     VARCHAR(40) NOT NULL,
                             C_NATIONKEY   INTEGER NOT NULL,
                             C_PHONE       CHAR(15) NOT NULL,
                             C_ACCTBAL     DECIMAL(15,2)   NOT NULL,
                             C_MKTSEGMENT  CHAR(10) NOT NULL,
                             C_COMMENT     VARCHAR(117) NOT NULL)
engine=brighthouse;
//*/

	{
	cout << "Create Table 'CUSTOMER' ..." << endl;
	TableSchema schema;
        schema.push_back(Attribut(INT,"C_CUSTKEY"));
        schema.push_back(Attribut(VARCHAR,"C_NAME"));
        schema.push_back(Attribut(VARCHAR,"C_ADDRESS"));
        schema.push_back(Attribut(INT,"C_NATIONKEY"));
        schema.push_back(Attribut(VARCHAR,"C_PHONE"));
        schema.push_back(Attribut(FLOAT,"C_ACCTBAL"));
        schema.push_back(Attribut(VARCHAR,"C_MKTSEGMENT"));
        schema.push_back(Attribut(VARCHAR,"C_COMMENT"));
	TablePtr tab(new Table("CUSTOMER",schema));

	if(tab->loadDatafromFile(path_to_files+"customer.tbl")){
	cout << "Store Table 'CUSTOMER' ..." << endl;
	storeTable(tab);
	}
	}

/*
CREATE TABLE orders  ( O_ORDERKEY       INTEGER NOT NULL,
                           O_CUSTKEY        INTEGER NOT NULL,
                           O_ORDERSTATUS    CHAR(1) NOT NULL,
                           O_TOTALPRICE     DECIMAL(15,2) NOT NULL,
                           O_ORDERDATE      DATE NOT NULL,
                           O_ORDERPRIORITY  CHAR(15) NOT NULL,  
                           O_CLERK          CHAR(15) NOT NULL, 
                           O_SHIPPRIORITY   INTEGER NOT NULL,
                           O_COMMENT        VARCHAR(79) NOT NULL)
engine=brighthouse;
//*/


	{
	cout << "Create Table 'ORDERS' ..." << endl;
	TableSchema schema;
        schema.push_back(Attribut(INT,"O_ORDERKEY"));
        schema.push_back(Attribut(INT,"O_CUSTKEY"));
        schema.push_back(Attribut(VARCHAR,"O_ORDERSTATUS"));
        schema.push_back(Attribut(FLOAT,"O_TOTALPRICE"));
        schema.push_back(Attribut(VARCHAR,"O_ORDERDATE"));
        schema.push_back(Attribut(VARCHAR,"O_ORDERPRIORITY"));  
        schema.push_back(Attribut(VARCHAR,"O_CLERK"));
        schema.push_back(Attribut(INT,"O_SHIPPRIORITY"));
        schema.push_back(Attribut(VARCHAR,"O_COMMENT"));
	TablePtr tab(new Table("ORDERS",schema));

	if(tab->loadDatafromFile(path_to_files+"orders.tbl")){
	cout << "Store Table 'ORDERS' ..." << endl;
	storeTable(tab);
	}
	}


//create table lineitem (
//l_orderkey    decimal(12,0) not null,
//l_partkey     decimal(10,0) not null,
//l_suppkey     decimal(8,0) not null,
//l_linenumber  decimal(1,0) not null,
//l_quantity    decimal(2,0) not null,
//l_extendedprice  decimal(8,2) not null,
//l_discount    decimal(3,2) not null,
//l_tax         decimal(3,2) not null,
//l_returnflag  char(1) not null,
//l_linestatus  char(1) not null,
//l_shipdate    date not null,
//l_commitdate  date not null,
//l_receiptdate date not null,
//l_shipinstruct char(25) not null,
//l_shipmode     char(10) not null,
//l_comment      varchar(44) not null
//) TYPE=MyISAM

	{
	cout << "Create Table 'LINEITEM' ..." << endl;
	Timestamp begin=getTimestamp();
	TableSchema schema;
	schema.push_back(Attribut(INT,"L_ORDERKEY"));//"L_ORDERKEY");   
	schema.push_back(Attribut(INT,"L_PARTKEY"));//l_partkey);
	schema.push_back(Attribut(INT,"L_SUPPKEY"));//l_suppkey);
	schema.push_back(Attribut(INT,"L_LINENUMBER"));//l_linenumber);
	schema.push_back(Attribut(INT,"L_QUANTITY"));//l_quantity );
	schema.push_back(Attribut(FLOAT,"L_EXTENDEDPRICE"));//l_extendedprice);
	schema.push_back(Attribut(FLOAT,"L_DISCOUNT"));//l_discount);
	schema.push_back(Attribut(FLOAT,"L_TAX"));//l_tax);
	schema.push_back(Attribut(VARCHAR,"L_RETURNFLAG"));//l_returnflag);
	schema.push_back(Attribut(VARCHAR,"L_LINESTATUS"));//l_linestatus );
	schema.push_back(Attribut(VARCHAR,"L_SHIPDATE"));//l_shipdate);
	schema.push_back(Attribut(VARCHAR,"L_COMMITDATE"));//l_commitdate);
	schema.push_back(Attribut(VARCHAR,"L_RECEIPTDATE"));//l_receiptdate);
	schema.push_back(Attribut(VARCHAR,"L_SHIPINSTRUCT"));//l_shipinstruct);
	schema.push_back(Attribut(VARCHAR,"L_SHIPMODE"));//l_shipmode);
	schema.push_back(Attribut(VARCHAR,"L_COMMENT"));//l_comment);


	TablePtr tab(new Table("LINEITEM",schema));

	if(tab->loadDatafromFile(path_to_files+"lineitem.tbl")){
	Timestamp end=getTimestamp();
	assert(end>=begin);
	cout << "Needed " << end-begin << "ns for import..." << endl;
	//tab->print();
	cout << "Store Table 'LINEITEM' ..." << endl;
	storeTable(tab);
	}
	}

	cout << "Successfully created TPCH Database!" << endl;
	return true;
}


}; //end namespace CogaDB

